package codechicken.lib.render.buffer;

import net.minecraft.client.renderer.BufferBuilder;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.client.renderer.vertex.VertexFormat;

/**
 * Created by covers1624 on 25/5/20.
 */
public class DelegateRenderType extends RenderType {

    protected RenderType parent;

    public DelegateRenderType(RenderType parent) {
        this(parent, parent.getVertexFormat());
    }

    public DelegateRenderType(RenderType parent, VertexFormat format) {
        super(parent.name, format, parent.getDrawMode(), parent.getBufferSize(), parent.isUseDelegate(), parent.needsSorting, null, null);
        this.parent = parent;
    }

    @Override
    public void finish(BufferBuilder p_228631_1_, int p_228631_2_, int p_228631_3_, int p_228631_4_) {
        parent.finish(p_228631_1_, p_228631_2_, p_228631_3_, p_228631_4_);
    }

    @Override
    public void setupRenderState() {
        parent.setupRenderState();
    }

    @Override
    public void clearRenderState() {
        parent.clearRenderState();
    }
}
